﻿// By Alexey Stukun st_verstka@mail.ru

try {
  var myDoc = app.activeDocument;
  } catch(error){
    exitScript("Нет открытых документов для работы.");
    }

// Собираем стили абзаца:
var parStylesList = []; 
for (i = 0; i < myDoc.paragraphStyles.length; i++) {
    parStylesList.push(myDoc.paragraphStyles[i].name);
}
parStylesList.splice(1, 1);

// Рисуем диалоговое окно:
var myDialog = app.dialogs.add({name:"Настройки " + app.activeScript.name + ":"});
with (myDialog) {
    with (dialogColumns.add()) {
        var parStylesEG = enablingGroups.add({staticLabel:"Только этот стиль абзаца:", checkedState: false, minWidth: 700});
        with (parStylesEG) {
            var parStyleBox = dropdowns.add({stringList: parStylesList, selectedIndex:0});
        }
        
        with (borderPanels.add().dialogColumns.add()) {
            dialogRows.add().staticTexts.add({staticLabel:"Область работы:"});
            var areaRB = radiobuttonGroups.add();
            with (areaRB) {
                var areaRBDoc = radiobuttonControls.add({ staticLabel: "Документ", minWidth: 172});
                var areaRBSpread = radiobuttonControls.add({ staticLabel: "Разворот", checkedState: true });             
                if (app.selection.length>0){
                    var areaRBSelect = radiobuttonControls.add({ staticLabel: "Выделение", checkedState: true });
                }
            }
        }
        
        with (borderPanels.add().dialogColumns.add()) {
            dialogRows.add().staticTexts.add({staticLabel: "Экспорт в формате:"});
            var formatRB = radiobuttonGroups.add();
            with (formatRB) {
                var RB = radiobuttonControls.add({ staticLabel: "txt", checkedState: true, minWidth: 172});
                var RB = radiobuttonControls.add({ staticLabel: "doc"});
                var RB = radiobuttonControls.add({ staticLabel: "rtf"});
            }
        }
        
        with (borderPanels.add().dialogColumns.add()) {
            dialogRows.add().staticTexts.add({staticLabel: "Имя файла:"});
            var idRB = radiobuttonGroups.add();
            with (idRB) {
                var numRB = radiobuttonControls.add({ staticLabel: "Номер страницы", checkedState: true, minWidth: 172});
                var zagRB = radiobuttonControls.add({ staticLabel: "Первая строка"});
            } 
        }
    }
}
var myDisplay = myDialog.show();
if (myDisplay != true) { exit(); }

var myFolder = chooseFolder("Куда сохранять файлы?");

// Считываем значения:
if (parStylesEG.checkedState === true) {
    var parStyle = myDoc.paragraphStyles.itemByName(parStylesList[parStyleBox.selectedIndex]);
}

switch (areaRB.selectedButton) {
    case 0:
    var myObjects = myDoc.textFrames;
    break;
    case 1:
    var myObjects = app.activeWindow.activeSpread.textFrames;
    break;
    case 2:
    var mySelection = app.selection;
    var myObjects = [];
    for (i = 0, iLen = mySelection.length; i < iLen; i++) {
        if (mySelection[i].constructor.name === "TextFrame") {
            var myObjects = myObjects.concat(mySelection[i]);
        }
     }
    break;
}

switch (formatRB.selectedButton) {
    case 0:
    var fileFormat = ".txt";
    break;
    case 1:
    var fileFormat = ".doc";
    break;
    case 2:
    var fileFormat = ".rtf";
    break;
}

// Перебираем текстовые фреймы:
var myTextFrames = [];
for (var i = 0, iLen = myObjects.length; i < iLen; i++) {
    var myTextFrames = myTextFrames.concat(myObjects[i]);
  }

for (var i = 0, iLen = myTextFrames.length; i < iLen; i++) {   
    
    var myFrame = myTextFrames[i];
    
    if (parStylesEG.checkedState === true && checkParStyle(myFrame, parStyle) === false) {
        continue;
    }

    if (myFrame.previousTextFrame) { continue; }
    // if (myFrame.paragraphs.length === 0) { continue; }
    // if (myFrame.locked === true) { continue; }
    
    // Создаем имя файла:
    if (numRB.checkedState) {
        try {
            var fileID = myFrame.parentPage.name;
            } catch (error) {
            var fileID = "PB";
        }
    } else {
        try {
            var fileID = myFrame.paragraphs[0].lines[0].contents;
            } catch (error) {
            var fileID = "no_text";
        }
    }
    fileID = fileID.replace(/(\n+|\r+)/g, "");
    fileID = fileID.replace(/(\s+|\n+|\r+|\\|\/|:|\*|\?|\"|\<|\>|\|)/g, "_");
    var myFileName =  fileID + fileFormat;
    
    // Проверяем, есть ли уже файл с таким именем:
    var myPath = myFolder + "/" + myFileName;
    myFile = checkAndRenameFile(myPath, 0);
    
    // Пишем файл:
    try {
        myFile.open('w');
        myFile.write(myFrame.parentStory.contents);
        myFile.close;
        } catch (error) {
    }
    
}

// Функции:

function checkAndRenameFile(path, nCounter) {
    myFile = File(path);
    if (myFile.exists) {
        nCounter++;
        var myNewPath = myPath.replace(fileFormat, "_" + nCounter + fileFormat);
        checkAndRenameFile(myNewPath, nCounter);
    }
    return myFile;
}

function checkParStyle(frame, style) {
    for (p = 0, pLen = frame.paragraphs.length; p < pLen; p++) {
        if (frame.paragraphs[p].appliedParagraphStyle == style) {
            return true;
        }
    }
    return false;
}

function chooseFolder(title) {
    var myFolder = Folder.selectDialog(title);
    if (myFolder == null) {
        exit();
        }
    return myFolder;
}

function doGrep(myFindWhat, myChangeTo) {
  app.findGrepPreferences = app.changparStyleEGrepPreferences = null;
  app.findGrepPreferences.findWhat = myFindWhat;
  app.changparStyleEGrepPreferences.changeTo = myChangeTo;
  myNewFrame.parentStory.changparStyleEGrep();
  app.findGrepPreferences = app.changparStyleEGrepPreferences = null;
}

function exitScript(myMessage) {
  alert(myMessage);
  exit();
}